""" Bounded model checking for transition systems """

import argparse
import os
import sys

from pysmt.typing import BOOL
from pysmt.shortcuts import Symbol, TRUE, FALSE, get_env, GE, Real, substitute
from pysmt.shortcuts import Not, And, Or, Implies, Iff, ExactlyOne, Not
from pysmt.shortcuts import is_valid, is_sat, reset_env, Solver
from pysmt.typing import REAL
from pysmt.exceptions import SolverAPINotFound

from ts import TS


def rename_f(ts, formula, i):
    """ Gets a formula with ts.state_vars and returns a formula where
    each state variable v ts.state_vars has been replaced with v_bmc_i and 
    every next variable for v has been replaced with v_bmc_i+1
    """
    replace_map = {}
    for var in ts.state_vars:
        replace_map[var] = Symbol("%s_bmc_%d" % (var.symbol_name(),i), var.symbol_type())
        v_next = ts.next_f(var)
        replace_map[v_next] = Symbol("%s_bmc_%d" % (var.symbol_name(),i+1), var.symbol_type())
    renamed = substitute(formula,replace_map)
    return renamed

def main():
    parser = argparse.ArgumentParser()
    parser.add_argument("--input")
    parser.add_argument("--k",  default=0, type=int)
    parser.add_argument("--i",  default=False, type=bool)
    args = parser.parse_args()

    input_file = args.input
    k  = args.k
    use_induction  = args.i

    # Read the TS system as input

    if not use_induction:
        # Iterate for all bounds from 0 to k
        # Encode the BMC problem at step i
        # Ask the SMT solver if the encoding is satisfiable (if yes, you have found a cex)
        # Increment the bound if the encoding is unsatisfiable
    else:
        # Check if the property is inductive

if __name__ == '__main__':
    main()

